package cz.muni.fi.pa165.facade;

import com.github.dozermapper.core.DozerBeanMapper;
import cz.muni.fi.pa165.dto.BaseDTO;
import cz.muni.fi.pa165.entity.BaseEntity;
import cz.muni.fi.pa165.services.BaseService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;
import java.util.UUID;

@Transactional
public class BaseFacadeImpl<GenericDTO extends BaseDTO, GenericService extends BaseService<GenericEntity>, GenericEntity extends BaseEntity> implements BaseFacade<GenericDTO, GenericEntity>{

    @Autowired
    protected GenericService service;
    @Autowired
    protected DozerBeanMapper mapper;

    @Override
    public GenericDTO findById(UUID id, GenericDTO dto) {
        mapper.map(service.findById(id), dto.getClass());

        return dto;
    }

    @Override
    public List<GenericDTO> getAll(List<GenericDTO> listDto) {
        mapper.map(service.findAll(), listDto);

        return listDto;
    }

    @Override
    public UUID create(GenericDTO dto, GenericEntity entity) {
        mapper.map(dto, entity);

        service.create(entity);

        return entity.getId();
    }
}
