package cz.muni.fi.pa165.facade;

import cz.muni.fi.pa165.dto.TournamentDTO;
import cz.muni.fi.pa165.entity.TeamEntity;
import cz.muni.fi.pa165.entity.TournamentEntity;
import cz.muni.fi.pa165.services.tournament.TournamentService;
import org.springframework.transaction.annotation.Transactional;
import java.util.ArrayList;
import java.util.List;

@Transactional
public class TournamentFacadeImpl extends BaseFacadeImpl<TournamentDTO, TournamentService, TournamentEntity> implements TournamentFacade{

    @Override
    public List<TournamentDTO> getTournamentByCity(String cityName) {
        List<TournamentDTO> listDto = new ArrayList<>();
        mapper.map(service.getTournamentsByCity(cityName), listDto);

        return listDto;
    }

    @Override
    public List<TournamentDTO> getTournamentsWonBy(TeamEntity team) {
        List<TournamentDTO> listDto = new ArrayList<>();
        mapper.map(service.getTournamentsWonBy(team), listDto);

        return listDto;
    }
}
